using System;
using System.Collections.Generic;
using System.Text;

namespace BusinessLib
{
	/// <summary>
	/// This describes a Customer of the Company
	/// </summary>
	/// <remarks>Do not use in Web environments...</remarks>
	/// <example>
	/// This is how you use this class:
	/// <code>
	/// Customer newCustomer = new Customer("John Smith", 24);
	/// </code>
	/// </example>
	public class Customer
	{

		#region Private Fields

		private string m_Name;
		private int m_Age;
		
		#endregion

		#region Constructor

		/// <summary>
		/// Constructor of the class
		/// </summary>
		/// <param name="name">Name of the customer</param>
		/// <param name="age">Age of the customer</param>
		public Customer(string name, int age)
		{
			m_Age = age;
			m_Name = name;
		}

		#endregion

		#region Public Properties

		/// <summary>
		/// Readonly property; returns the name of the customer
		/// </summary>
		public string Name
		{
			get { return m_Name; }
		}

		/// <summary>
		/// Readonly property returning the age of the customer
		/// </summary>
		public int Age
		{
			get { return m_Age; }
		}

		#endregion

	}
}
