using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace ReflectionDemo
{
	class Program
	{
		static void Main(string[] args)
		{
			// Load the assembly in memory, specified in the path
			// CHANGE THE PATH TO A VALID ONE IN YOUR SYSTEM!
			string path = @"C:\Documents and Settings\Getronics User\Desktop\ReflectionDemo\ClassLibrary1\bin\Debug\ClassLibrary1.dll";
			Assembly assembly = Assembly.LoadFile(path);

			// Get basic info about the assembly
			Console.WriteLine("Analizing assembly {0}", assembly.FullName);
			Console.WriteLine("==================");
			Type [] classes = assembly.GetTypes();

			// Iterate and show information about the types stored in the assembly
			Console.WriteLine("Classes in assembly:");
			Console.WriteLine("=====================");
			for (int i = 0; i < classes.Length; i++)
			{
				Type classObject = classes[i];
				Console.WriteLine();
				Console.WriteLine("{0}: {1}", i, classObject.FullName);
				Console.WriteLine("--------------");

				// Retrieve all the methods inside the assembly and show some data about them
				MethodInfo[] methods = classObject.GetMethods(BindingFlags.Public 
					| BindingFlags.Instance | BindingFlags.DeclaredOnly);

				for (int j = 0; j < methods.Length; j++)
				{
					MethodInfo method = methods[j];
					Console.WriteLine("Method {0} (Returns {1})", method.Name, method.ReturnType.FullName);
				}
			}

			// Create an instance of a type dynamically
			Console.WriteLine();
			Console.WriteLine("Dynamic instance creation");
			Console.WriteLine("=========================");
			Type uneClasse = assembly.GetType("ClassLibrary1.SomeClass");
			object instance = Activator.CreateInstance(uneClasse);
			MethodInfo methodObject = uneClasse.GetMethod("TellMeSomething");
			methodObject.Invoke(instance, null);

			Console.WriteLine();
			Console.WriteLine("Attributes of TellMeSomething:");
			Console.WriteLine("==============================");
			object[] attributes = methodObject.GetCustomAttributes(false);

			foreach (object att in attributes)
			{
				if (att is Attribute)
				{
					Attribute temp = (Attribute)att;
					Console.WriteLine(att.GetType().Name);
				}
			}

			assembly = null;
			Console.ReadLine();
		}
	}
}
