using System;
using System.Collections.Generic;
using System.Text;

namespace StringAppend
{
    class Program
    {
        static void Main(string[] args)
        {
            // First, use a pure concatenation method

            int start = Environment.TickCount;
            for (int i = 0; i < 1000; i++)
            {
                string s = "";
                for (int j = 0; j < 100; j++)
                {
                    s += "Outer index = ";
                    s += i;
                    s += " Inner index = ";
                    s += j;
                    s += " ";
                }
            }
            Console.WriteLine("Program ran for {0} seconds", 0.001 * (Environment.TickCount - start));

            // After, use a StringBuilder instead...

            start = Environment.TickCount;
            for (int i = 0; i < 1000; i++)
            {
                StringBuilder sb = new StringBuilder();
                for (int j = 0; j < 100; j++)
                {
                    sb.Append("Outer index = ");
                    sb.Append(i);
                    sb.Append(" Inner index = ");
                    sb.Append(j);
                    sb.Append(" ");
                }
                string s = sb.ToString();
            }
            Console.WriteLine("Program ran for {0} seconds", 0.001 * (Environment.TickCount - start));

            Console.ReadLine();
        }
    }
}
