using System;
using System.Collections.Generic;
using System.Text;

namespace Kosmaczewski.DistributedApp.BusinessDataEntities
{
	/// <summary>
	/// Represents an Employee of the Northwind company.
	/// </summary>
	public class Employee
	{
		private string m_FirstName;
		private string m_LastName;
		private int m_EmployeeId;

		/// <summary>
		/// Gets or sets the first name of the current employee.
		/// </summary>
		public string FirstName
		{
			get 
			{
				return m_FirstName; 
			}
			set 
			{ 
				m_FirstName = value; 
			}
		}

		/// <summary>
		/// Gets or sets the last name of the current employee.
		/// </summary>
		public string LastName
		{
			get 
			{ 
				return m_LastName; 
			}
			set 
			{ 
				m_LastName = value; 
			}
		}

		/// <summary>
		/// Gets or sets the ID of the current employee.
		/// </summary>
		public int EmployeeId
		{
			get 
			{ 
				return m_EmployeeId; 
			}
			set 
			{ 
				m_EmployeeId = value; 
			}
		}
	}
}
