using System;
using System.Collections.Generic;
using System.Text;

namespace Kosmaczewski.DistributedApp.BusinessDataEntities
{
	/// <summary>
	/// Represents an Order
	/// </summary>
	public class Order
	{
		private int m_OrderId;
		private string m_CustomerId;
		private int m_EmployeeId;

		/// <summary>
		/// Gets or sets the ID of the current instance.
		/// </summary>
		public int OrderId
		{
			get
			{
				return m_OrderId;
			}
			set 
			{ 
				m_OrderId = value; 
			}
		}

		/// <summary>
		/// Gets or sets the ID of the customer of the current order.
		/// </summary>
		public string CustomerId
		{
			get 
			{ 
				return m_CustomerId; 
			}
			set 
			{ 
				m_CustomerId = value; 
			}
		}

		/// <summary>
		/// Gets or sets the ID of the employee responsible for
		/// the current order.
		/// </summary>
		public int EmployeeId
		{
			get 
			{ 
				return m_EmployeeId; 
			}
			set 
			{ 
				m_EmployeeId = value; 
			}
		}
	}
}
