using System;
using System.Collections.Generic;
using System.Data;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using Kosmaczewski.DistributedApp.BusinessLibrary;
using Kosmaczewski.DistributedApp.BusinessDataEntities;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
public class Service : System.Web.Services.WebService
{
    public Service () {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    [WebMethod]
    public List<Employee> GetEmployees()
	{
		List<Employee> employees = null;
		using (BusinessDataManager manager = new BusinessDataManager())
		{
			employees = manager.GetEmployees();
		}
		return employees;
    }

	[WebMethod]
	public List<Order> GetOrders()
	{
		List<Order> orders = null;
		using (BusinessDataManager manager = new BusinessDataManager())
		{
			orders = manager.GetOrders();
		}

        // This helps simulating a long-running webservice
		System.Threading.Thread.Sleep(5000);
		return orders;
	}

	[WebMethod]
	public Order GetOrderById(int orderId)
	{
		Order order = null;
		using (BusinessDataManager manager = new BusinessDataManager())
		{
			order = manager.GetOrderById(orderId);
		}
		return order;
	}
    
}
