﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using Kosmaczewski.DistributedApp.BusinessLibrary;
using Kosmaczewski.DistributedApp.BusinessDataEntities;
using System.Data;

namespace DistrAppTests
{
	/// <summary>
	///This is a test class for Kosmaczewski.DistributedApp.BusinessLibrary.BusinessDataManager and is intended
	///to contain all Kosmaczewski.DistributedApp.BusinessLibrary.BusinessDataManager Unit Tests
	///</summary>
	[TestClass()]
	public class BusinessDataManagerTest
	{
		private TestContext testContextInstance;

		/// <summary>
		///Gets or sets the test context which provides
		///information about and functionality for the current test run.
		///</summary>
		public TestContext TestContext
		{
			get
			{
				return testContextInstance;
			}
			set
			{
				testContextInstance = value;
			}
		}
		#region Additional test attributes
		// 
		//You can use the following additional attributes as you write your tests:
		//
		//Use ClassInitialize to run code before running the first test in the class
		//
		//[ClassInitialize()]
		//public static void MyClassInitialize(TestContext testContext)
		//{
		//}
		//
		//Use ClassCleanup to run code after all tests in a class have run
		//
		//[ClassCleanup()]
		//public static void MyClassCleanup()
		//{
		//}
		//
		//Use TestInitialize to run code before running each test
		//
		//[TestInitialize()]
		//public void MyTestInitialize()
		//{
		//}
		//
		//Use TestCleanup to run code after each test has run
		//
		//[TestCleanup()]
		//public void MyTestCleanup()
		//{
		//}
		//
		#endregion

		/// <summary>
		///A test for GetEmployees ()
		///</summary>
		[TestMethod()]
		public void GetEmployeesTest()
		{
			using (BusinessDataManager target = new BusinessDataManager())
			{
				List<Employee> actual = target.GetEmployees();
				Assert.AreEqual(actual.Count, 9, "Kosmaczewski.DistributedApp.BusinessLibrary.Business.GetEmployees did not return the expected value.");
			}
		}

		/// <summary>
		///A test for GetOrders ()
		///</summary>
		[TestMethod()]
		public void GetOrdersTest()
		{
			using (BusinessDataManager target = new BusinessDataManager())
			{
				List<Order> actual = target.GetOrders();
				Assert.AreEqual(actual.Count, 830, "Kosmaczewski.DistributedApp.BusinessLibrary.BusinessDataManager.GetOrders did not return the expected value.");
			}
		}

		/// <summary>
		///A test for GetOrderById (int)
		///</summary>
		[TestMethod()]
		public void GetOrderByIdTest()
		{
			using (BusinessDataManager target = new BusinessDataManager())
			{
				int orderId = 10253;

				Order order = target.GetOrderById(orderId);
				Assert.IsNotNull(order, "The Order must not be null");
				Assert.AreEqual("HANAR", order.CustomerId, "The order returned is incorrect");
			}
		}
	}
}
